/**
Copyright: 2024 Contrast Security, Inc
  Contact: support@contrastsecurity.com
  License: Commercial

  NOTICE: This Software and the patented inventions embodied within may only be
  used as part of Contrast Security’s commercial offerings. Even though it is
  made available through public repositories, use of this Software is subject to
  the applicable End User Licensing Agreement found at
  https://www.contrastsecurity.com/enduser-terms-0317a or as otherwise agreed
  between Contrast Security and the End User. The Software may not be reverse
  engineered, modified, repackaged, sold, redistributed or otherwise used in a
  way not consistent with the End User License Agreement.
*/
'use strict';

const { settings } = require('@contrast/protobuf-api');
const { STRING_DEFINITION_TYPE } = require('../../enums');
const { wrapToObject } = require('../../helpers');

function StringDefinition({ caseSensitive, id, rule, score, type, value }) {
  return new settings.StringDefinition([
    type, //               1           type
    rule, //               2           rule
    id, //                 3             id
    value, //              4          value
    caseSensitive, //      5 case_sensitive
    score, //              6          score
    value.toLowerCase() // 7       downcase
  ]);
}

function toKeyword(name, definition) {
  return Object.assign({ type: 0, rule: name }, definition);
}

function toPattern(name, definition) {
  return Object.assign({ type: 1, rule: name }, definition);
}

function RuleDefinition({ name, keywords = [], patterns = [] } = {}) {
  return wrapToObject(
    new settings.RuleDefinition([
      name, //                                                                1     name
      keywords.map((def) => StringDefinition(toKeyword(name, def)).array), // 2 keywords
      patterns.map((def) => StringDefinition(toPattern(name, def)).array) //  3 patterns
    ]),
    (definitions) => {
      definitions.keywordsList.forEach((definition) => {
        definition.type = STRING_DEFINITION_TYPE[definition.type];
      });
      definitions.patternsList.forEach((definition) => {
        definition.type = STRING_DEFINITION_TYPE[definition.type];
      });
    }
  );
}

module.exports = RuleDefinition;
